/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
package com.twitter.finagle.thrift.thrift;

import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.thrift.*;
import org.apache.thrift.async.*;
import org.apache.thrift.meta_data.*;
import org.apache.thrift.transport.*;
import org.apache.thrift.protocol.*;

// No additional import required for struct/union.

/**
 * RequestHeader defines headers for the request. These carry the span data, and
 * a flag indicating whether the request is to be debugged.
 */
public class RequestHeader implements TBase<RequestHeader, RequestHeader._Fields>, java.io.Serializable, Cloneable {
  private static final TStruct STRUCT_DESC = new TStruct("RequestHeader");

  private static final TField TRACE_ID_FIELD_DESC = new TField("trace_id", TType.I64, (short)1);
  private static final TField SPAN_ID_FIELD_DESC = new TField("span_id", TType.I64, (short)2);
  private static final TField PARENT_SPAN_ID_FIELD_DESC = new TField("parent_span_id", TType.I64, (short)3);
  private static final TField SAMPLED_FIELD_DESC = new TField("sampled", TType.BOOL, (short)5);
  private static final TField CLIENT_ID_FIELD_DESC = new TField("client_id", TType.STRUCT, (short)6);
  private static final TField FLAGS_FIELD_DESC = new TField("flags", TType.I64, (short)7);

  public long trace_id;
  public long span_id;
  public long parent_span_id;
  public boolean sampled;
  public ClientId client_id;
  public long flags;

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements TFieldIdEnum {
    TRACE_ID((short)1, "trace_id"),
    SPAN_ID((short)2, "span_id"),
    PARENT_SPAN_ID((short)3, "parent_span_id"),
    SAMPLED((short)5, "sampled"),
    CLIENT_ID((short)6, "client_id"),
    FLAGS((short)7, "flags");

    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // TRACE_ID
          return TRACE_ID;
        case 2: // SPAN_ID
          return SPAN_ID;
        case 3: // PARENT_SPAN_ID
          return PARENT_SPAN_ID;
        case 5: // SAMPLED
          return SAMPLED;
        case 6: // CLIENT_ID
          return CLIENT_ID;
        case 7: // FLAGS
          return FLAGS;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __TRACE_ID_ISSET_ID = 0;
  private static final int __SPAN_ID_ISSET_ID = 1;
  private static final int __PARENT_SPAN_ID_ISSET_ID = 2;
  private static final int __SAMPLED_ISSET_ID = 3;
  private static final int __FLAGS_ISSET_ID = 4;
  private BitSet __isset_bit_vector = new BitSet(5);

  public static final Map<_Fields, FieldMetaData> metaDataMap;
  static {
    Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.TRACE_ID, new FieldMetaData("trace_id", TFieldRequirementType.DEFAULT, 
        new FieldValueMetaData(TType.I64)));
    tmpMap.put(_Fields.SPAN_ID, new FieldMetaData("span_id", TFieldRequirementType.DEFAULT, 
        new FieldValueMetaData(TType.I64)));
    tmpMap.put(_Fields.PARENT_SPAN_ID, new FieldMetaData("parent_span_id", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.I64)));
    tmpMap.put(_Fields.SAMPLED, new FieldMetaData("sampled", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.BOOL)));
    tmpMap.put(_Fields.CLIENT_ID, new FieldMetaData("client_id", TFieldRequirementType.OPTIONAL, 
        new StructMetaData(TType.STRUCT, ClientId.class)));
    tmpMap.put(_Fields.FLAGS, new FieldMetaData("flags", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.I64)));
    metaDataMap = Collections.unmodifiableMap(tmpMap);
    FieldMetaData.addStructMetaDataMap(RequestHeader.class, metaDataMap);
  }

  public RequestHeader() {
  }

  public RequestHeader(
    long trace_id,
    long span_id)
  {
    this();
    this.trace_id = trace_id;
    setTrace_idIsSet(true);
    this.span_id = span_id;
    setSpan_idIsSet(true);
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public RequestHeader(RequestHeader other) {
    __isset_bit_vector.clear();
    __isset_bit_vector.or(other.__isset_bit_vector);
    this.trace_id = other.trace_id;
    this.span_id = other.span_id;
    this.parent_span_id = other.parent_span_id;
    this.sampled = other.sampled;
    if (other.isSetClient_id()) {
      this.client_id = new ClientId(other.client_id);
    }
    this.flags = other.flags;
  }

  public RequestHeader deepCopy() {
    return new RequestHeader(this);
  }

  @Override
  public void clear() {
    setTrace_idIsSet(false);
    this.trace_id = 0;
    setSpan_idIsSet(false);
    this.span_id = 0;
    setParent_span_idIsSet(false);
    this.parent_span_id = 0;
    setSampledIsSet(false);
    this.sampled = false;
    this.client_id = null;
    setFlagsIsSet(false);
    this.flags = 0;
  }

  public long getTrace_id() {
    return this.trace_id;
  }

  public RequestHeader setTrace_id(long trace_id) {
    this.trace_id = trace_id;
    setTrace_idIsSet(true);
    return this;
  }

  public void unsetTrace_id() {
    __isset_bit_vector.clear(__TRACE_ID_ISSET_ID);
  }

  /** Returns true if field trace_id is set (has been asigned a value) and false otherwise */
  public boolean isSetTrace_id() {
    return __isset_bit_vector.get(__TRACE_ID_ISSET_ID);
  }

  public void setTrace_idIsSet(boolean value) {
    __isset_bit_vector.set(__TRACE_ID_ISSET_ID, value);
  }

  public long getSpan_id() {
    return this.span_id;
  }

  public RequestHeader setSpan_id(long span_id) {
    this.span_id = span_id;
    setSpan_idIsSet(true);
    return this;
  }

  public void unsetSpan_id() {
    __isset_bit_vector.clear(__SPAN_ID_ISSET_ID);
  }

  /** Returns true if field span_id is set (has been asigned a value) and false otherwise */
  public boolean isSetSpan_id() {
    return __isset_bit_vector.get(__SPAN_ID_ISSET_ID);
  }

  public void setSpan_idIsSet(boolean value) {
    __isset_bit_vector.set(__SPAN_ID_ISSET_ID, value);
  }

  public long getParent_span_id() {
    return this.parent_span_id;
  }

  public RequestHeader setParent_span_id(long parent_span_id) {
    this.parent_span_id = parent_span_id;
    setParent_span_idIsSet(true);
    return this;
  }

  public void unsetParent_span_id() {
    __isset_bit_vector.clear(__PARENT_SPAN_ID_ISSET_ID);
  }

  /** Returns true if field parent_span_id is set (has been asigned a value) and false otherwise */
  public boolean isSetParent_span_id() {
    return __isset_bit_vector.get(__PARENT_SPAN_ID_ISSET_ID);
  }

  public void setParent_span_idIsSet(boolean value) {
    __isset_bit_vector.set(__PARENT_SPAN_ID_ISSET_ID, value);
  }

  public boolean isSampled() {
    return this.sampled;
  }

  public RequestHeader setSampled(boolean sampled) {
    this.sampled = sampled;
    setSampledIsSet(true);
    return this;
  }

  public void unsetSampled() {
    __isset_bit_vector.clear(__SAMPLED_ISSET_ID);
  }

  /** Returns true if field sampled is set (has been asigned a value) and false otherwise */
  public boolean isSetSampled() {
    return __isset_bit_vector.get(__SAMPLED_ISSET_ID);
  }

  public void setSampledIsSet(boolean value) {
    __isset_bit_vector.set(__SAMPLED_ISSET_ID, value);
  }

  public ClientId getClient_id() {
    return this.client_id;
  }

  public RequestHeader setClient_id(ClientId client_id) {
    this.client_id = client_id;
    return this;
  }

  public void unsetClient_id() {
    this.client_id = null;
  }

  /** Returns true if field client_id is set (has been asigned a value) and false otherwise */
  public boolean isSetClient_id() {
    return this.client_id != null;
  }

  public void setClient_idIsSet(boolean value) {
    if (!value) {
      this.client_id = null;
    }
  }

  public long getFlags() {
    return this.flags;
  }

  public RequestHeader setFlags(long flags) {
    this.flags = flags;
    setFlagsIsSet(true);
    return this;
  }

  public void unsetFlags() {
    __isset_bit_vector.clear(__FLAGS_ISSET_ID);
  }

  /** Returns true if field flags is set (has been asigned a value) and false otherwise */
  public boolean isSetFlags() {
    return __isset_bit_vector.get(__FLAGS_ISSET_ID);
  }

  public void setFlagsIsSet(boolean value) {
    __isset_bit_vector.set(__FLAGS_ISSET_ID, value);
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case TRACE_ID:
      if (value == null) {
        unsetTrace_id();
      } else {
        setTrace_id((Long)value);
      }
      break;

    case SPAN_ID:
      if (value == null) {
        unsetSpan_id();
      } else {
        setSpan_id((Long)value);
      }
      break;

    case PARENT_SPAN_ID:
      if (value == null) {
        unsetParent_span_id();
      } else {
        setParent_span_id((Long)value);
      }
      break;

    case SAMPLED:
      if (value == null) {
        unsetSampled();
      } else {
        setSampled((Boolean)value);
      }
      break;

    case CLIENT_ID:
      if (value == null) {
        unsetClient_id();
      } else {
        setClient_id((ClientId)value);
      }
      break;

    case FLAGS:
      if (value == null) {
        unsetFlags();
      } else {
        setFlags((Long)value);
      }
      break;

    }
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case TRACE_ID:
      return new Long(getTrace_id());

    case SPAN_ID:
      return new Long(getSpan_id());

    case PARENT_SPAN_ID:
      return new Long(getParent_span_id());

    case SAMPLED:
      return new Boolean(isSampled());

    case CLIENT_ID:
      return getClient_id();

    case FLAGS:
      return new Long(getFlags());

    }
    throw new IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new IllegalArgumentException();
    }

    switch (field) {
    case TRACE_ID:
      return isSetTrace_id();
    case SPAN_ID:
      return isSetSpan_id();
    case PARENT_SPAN_ID:
      return isSetParent_span_id();
    case SAMPLED:
      return isSetSampled();
    case CLIENT_ID:
      return isSetClient_id();
    case FLAGS:
      return isSetFlags();
    }
    throw new IllegalStateException();
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof RequestHeader)
      return this.equals((RequestHeader)that);
    return false;
  }

  public boolean equals(RequestHeader that) {
    if (that == null)
      return false;

    boolean this_present_trace_id = true;
    boolean that_present_trace_id = true;
    if (this_present_trace_id || that_present_trace_id) {
      if (!(this_present_trace_id && that_present_trace_id))
        return false;
      if (this.trace_id != that.trace_id)
        return false;
    }

    boolean this_present_span_id = true;
    boolean that_present_span_id = true;
    if (this_present_span_id || that_present_span_id) {
      if (!(this_present_span_id && that_present_span_id))
        return false;
      if (this.span_id != that.span_id)
        return false;
    }

    boolean this_present_parent_span_id = true && this.isSetParent_span_id();
    boolean that_present_parent_span_id = true && that.isSetParent_span_id();
    if (this_present_parent_span_id || that_present_parent_span_id) {
      if (!(this_present_parent_span_id && that_present_parent_span_id))
        return false;
      if (this.parent_span_id != that.parent_span_id)
        return false;
    }

    boolean this_present_sampled = true && this.isSetSampled();
    boolean that_present_sampled = true && that.isSetSampled();
    if (this_present_sampled || that_present_sampled) {
      if (!(this_present_sampled && that_present_sampled))
        return false;
      if (this.sampled != that.sampled)
        return false;
    }

    boolean this_present_client_id = true && this.isSetClient_id();
    boolean that_present_client_id = true && that.isSetClient_id();
    if (this_present_client_id || that_present_client_id) {
      if (!(this_present_client_id && that_present_client_id))
        return false;
      if (!this.client_id.equals(that.client_id))
        return false;
    }

    boolean this_present_flags = true && this.isSetFlags();
    boolean that_present_flags = true && that.isSetFlags();
    if (this_present_flags || that_present_flags) {
      if (!(this_present_flags && that_present_flags))
        return false;
      if (this.flags != that.flags)
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    return 0;
  }

  public int compareTo(RequestHeader other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;
    RequestHeader typedOther = (RequestHeader)other;

    lastComparison = Boolean.valueOf(isSetTrace_id()).compareTo(typedOther.isSetTrace_id());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetTrace_id()) {
      lastComparison = TBaseHelper.compareTo(this.trace_id, typedOther.trace_id);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetSpan_id()).compareTo(typedOther.isSetSpan_id());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetSpan_id()) {
      lastComparison = TBaseHelper.compareTo(this.span_id, typedOther.span_id);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetParent_span_id()).compareTo(typedOther.isSetParent_span_id());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetParent_span_id()) {
      lastComparison = TBaseHelper.compareTo(this.parent_span_id, typedOther.parent_span_id);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetSampled()).compareTo(typedOther.isSetSampled());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetSampled()) {
      lastComparison = TBaseHelper.compareTo(this.sampled, typedOther.sampled);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetClient_id()).compareTo(typedOther.isSetClient_id());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetClient_id()) {
      lastComparison = TBaseHelper.compareTo(this.client_id, typedOther.client_id);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetFlags()).compareTo(typedOther.isSetFlags());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetFlags()) {
      lastComparison = TBaseHelper.compareTo(this.flags, typedOther.flags);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(TProtocol iprot) throws TException {
    TField field;
    iprot.readStructBegin();
    while (true)
    {
      field = iprot.readFieldBegin();
      if (field.type == TType.STOP) { 
        break;
      }
      switch (field.id) {
        case 1: // TRACE_ID
          if (field.type == TType.I64) {
            this.trace_id = iprot.readI64();
            setTrace_idIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 2: // SPAN_ID
          if (field.type == TType.I64) {
            this.span_id = iprot.readI64();
            setSpan_idIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 3: // PARENT_SPAN_ID
          if (field.type == TType.I64) {
            this.parent_span_id = iprot.readI64();
            setParent_span_idIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 5: // SAMPLED
          if (field.type == TType.BOOL) {
            this.sampled = iprot.readBool();
            setSampledIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 6: // CLIENT_ID
          if (field.type == TType.STRUCT) {
            this.client_id = new ClientId();
            this.client_id.read(iprot);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 7: // FLAGS
          if (field.type == TType.I64) {
            this.flags = iprot.readI64();
            setFlagsIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        default:
          TProtocolUtil.skip(iprot, field.type);
      }
      iprot.readFieldEnd();
    }
    iprot.readStructEnd();

    // check for required fields of primitive type, which can't be checked in the validate method
    validate();
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    oprot.writeFieldBegin(TRACE_ID_FIELD_DESC);
    oprot.writeI64(this.trace_id);
    oprot.writeFieldEnd();
    oprot.writeFieldBegin(SPAN_ID_FIELD_DESC);
    oprot.writeI64(this.span_id);
    oprot.writeFieldEnd();
    if (isSetParent_span_id()) {
      oprot.writeFieldBegin(PARENT_SPAN_ID_FIELD_DESC);
      oprot.writeI64(this.parent_span_id);
      oprot.writeFieldEnd();
    }
    if (isSetSampled()) {
      oprot.writeFieldBegin(SAMPLED_FIELD_DESC);
      oprot.writeBool(this.sampled);
      oprot.writeFieldEnd();
    }
    if (this.client_id != null) {
      if (isSetClient_id()) {
        oprot.writeFieldBegin(CLIENT_ID_FIELD_DESC);
        this.client_id.write(oprot);
        oprot.writeFieldEnd();
      }
    }
    if (isSetFlags()) {
      oprot.writeFieldBegin(FLAGS_FIELD_DESC);
      oprot.writeI64(this.flags);
      oprot.writeFieldEnd();
    }
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("RequestHeader(");
    boolean first = true;

    sb.append("trace_id:");
    sb.append(this.trace_id);
    first = false;
    if (!first) sb.append(", ");
    sb.append("span_id:");
    sb.append(this.span_id);
    first = false;
    if (isSetParent_span_id()) {
      if (!first) sb.append(", ");
      sb.append("parent_span_id:");
      sb.append(this.parent_span_id);
      first = false;
    }
    if (isSetSampled()) {
      if (!first) sb.append(", ");
      sb.append("sampled:");
      sb.append(this.sampled);
      first = false;
    }
    if (isSetClient_id()) {
      if (!first) sb.append(", ");
      sb.append("client_id:");
      if (this.client_id == null) {
        sb.append("null");
      } else {
        sb.append(this.client_id);
      }
      first = false;
    }
    if (isSetFlags()) {
      if (!first) sb.append(", ");
      sb.append("flags:");
      sb.append(this.flags);
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws TException {
    // check for required fields
  }

}

